---
product: "AG Studio"
title: "Page Settings"
description: "Page settings control a page's dimensions and its layout grid."
framework: react
version: "3.0.0"
related:
    - title: "User Interface"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Page Settings

Page settings control a page's dimensions and its layout grid.

The layout grid positions Widgets within the page. AG Studio pages are designed to respond to different viewport sizes: the page and its Widgets resize within the defined boundaries while maintaining their relative positions on the grid.

These settings are defined as part of the page configuration. In the default setup, they are not edited through the Studio UI.

> **Note**
>
> For the most predictable results, page dimensions and layout grid settings should be defined before Widgets are added.

## Layout Grid

After the page size is defined, the layout grid determines how that space is divided for [Widget](https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/) placement.

The layout grid is invisible but essential. It provides a consistent framework so Widgets line up neatly and behave predictably as they resize. Widget positions and sizes are defined against this grid rather than absolute screen coordinates.

Columns divide the page horizontally into sections. More Columns provide finer control when sizing and positioning Widgets. Fewer Columns use larger steps.

Row Height controls the vertical spacing unit in pixels. A smaller Row Height provides more precise vertical control, while a larger Row Height uses bigger steps.

As the Viewport changes size, Widgets keep their relative positions on the layout grid. Because Widgets align to this grid, sensible values should be chosen before building the page. This helps prevent Widgets from shifting unexpectedly later.

When a Widget is moved or resized:

- AG Studio shows a preview of where it will be placed
- Widgets automatically align to the grid (this is called snapping)
- If a Widget would go outside the page boundary, it stops at the edge (this is called clamping)
- When released, the Widget settles into the nearest available grid-aligned position within the page bounds

This automatic alignment helps keep Widgets neatly organised, even near the edges.

Try dragging the widget in the example below to see the grid lines and snapping behaviour in action.

#### Layout Grid

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "gold-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Gold Medals",
                },
              },
            },
            "silver-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.silver", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Silver Medals",
                },
              },
            },
            "bronze-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.bronze", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Bronze Medals",
                },
              },
            },
          },
          widgetLayout: {
            "gold-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
            "silver-medals": {
              xTrack: 6,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
            "bronze-medals": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: [],
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/layout-grid/reactFunctionalTs/)

## Customisations

Page settings also include universal styling options that apply across the page. At page level, the page background can be changed and default Widget styles can be defined. Each widget can override those defaults from the Widget section of its own Format tab.

Click on the page section in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#edit-panel) to access page customisation options and see how styling changes take effect across the page.

#### Page Customisation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "gold-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Gold Medals",
                },
              },
            },
            "silver-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.silver", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Silver Medals",
                },
              },
            },
            "bronze-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.bronze", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Bronze Medals",
                },
              },
            },
          },
          widgetLayout: {
            "gold-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
            "silver-medals": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
            "bronze-medals": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Page Customisation](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/page-customisation/reactFunctionalTs/)


---
product: "AG Studio"
title: "Page Settings"
description: "Page settings control a page's dimensions and its layout grid."
framework: vue
version: "3.0.0"
related:
    - title: "User Interface"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Page Settings

Page settings control a page's dimensions and its layout grid.

The layout grid positions Widgets within the page. AG Studio pages are designed to respond to different viewport sizes: the page and its Widgets resize within the defined boundaries while maintaining their relative positions on the grid.

These settings are defined as part of the page configuration. In the default setup, they are not edited through the Studio UI.

> **Note**
>
> For the most predictable results, page dimensions and layout grid settings should be defined before Widgets are added.

## Layout Grid

After the page size is defined, the layout grid determines how that space is divided for [Widget](https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/) placement.

The layout grid is invisible but essential. It provides a consistent framework so Widgets line up neatly and behave predictably as they resize. Widget positions and sizes are defined against this grid rather than absolute screen coordinates.

Columns divide the page horizontally into sections. More Columns provide finer control when sizing and positioning Widgets. Fewer Columns use larger steps.

Row Height controls the vertical spacing unit in pixels. A smaller Row Height provides more precise vertical control, while a larger Row Height uses bigger steps.

As the Viewport changes size, Widgets keep their relative positions on the layout grid. Because Widgets align to this grid, sensible values should be chosen before building the page. This helps prevent Widgets from shifting unexpectedly later.

When a Widget is moved or resized:

- AG Studio shows a preview of where it will be placed
- Widgets automatically align to the grid (this is called snapping)
- If a Widget would go outside the page boundary, it stops at the edge (this is called clamping)
- When released, the Widget settles into the nearest available grid-aligned position within the page bounds

This automatic alignment helps keep Widgets neatly organised, even near the edges.

Try dragging the widget in the example below to see the grid lines and snapping behaviour in action.

#### Layout Grid

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "gold-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Gold Medals",
                },
              },
            },
            "silver-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.silver", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Silver Medals",
                },
              },
            },
            "bronze-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.bronze", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Bronze Medals",
                },
              },
            },
          },
          widgetLayout: {
            "gold-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
            "silver-medals": {
              xTrack: 6,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
            "bronze-medals": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 6,
              ySpan: 6,
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: [],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/layout-grid/vue3/)

## Customisations

Page settings also include universal styling options that apply across the page. At page level, the page background can be changed and default Widget styles can be defined. Each widget can override those defaults from the Widget section of its own Format tab.

Click on the page section in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#edit-panel) to access page customisation options and see how styling changes take effect across the page.

#### Page Customisation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "gold-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Gold Medals",
                },
              },
            },
            "silver-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.silver", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Silver Medals",
                },
              },
            },
            "bronze-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.bronze", aggregation: "sum" }],
              },
              format: {
                caption: {
                  enabled: true,
                  text: "Bronze Medals",
                },
              },
            },
          },
          widgetLayout: {
            "gold-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
            "silver-medals": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
            "bronze-medals": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 8,
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Page Customisation](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/page-customisation/vue3/)


---
product: "AG Studio"
title: "Page Settings"
description: "Page settings control a page's dimensions and its layout grid."
framework: angular
version: "3.0.0"
related:
    - title: "User Interface"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Page Settings

Page settings control a page's dimensions and its layout grid.

The layout grid positions Widgets within the page. AG Studio pages are designed to respond to different viewport sizes: the page and its Widgets resize within the defined boundaries while maintaining their relative positions on the grid.

These settings are defined as part of the page configuration. In the default setup, they are not edited through the Studio UI.

> **Note**
>
> For the most predictable results, page dimensions and layout grid settings should be defined before Widgets are added.

## Layout Grid

After the page size is defined, the layout grid determines how that space is divided for [Widget](https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/) placement.

The layout grid is invisible but essential. It provides a consistent framework so Widgets line up neatly and behave predictably as they resize. Widget positions and sizes are defined against this grid rather than absolute screen coordinates.

Columns divide the page horizontally into sections. More Columns provide finer control when sizing and positioning Widgets. Fewer Columns use larger steps.

Row Height controls the vertical spacing unit in pixels. A smaller Row Height provides more precise vertical control, while a larger Row Height uses bigger steps.

As the Viewport changes size, Widgets keep their relative positions on the layout grid. Because Widgets align to this grid, sensible values should be chosen before building the page. This helps prevent Widgets from shifting unexpectedly later.

When a Widget is moved or resized:

- AG Studio shows a preview of where it will be placed
- Widgets automatically align to the grid (this is called snapping)
- If a Widget would go outside the page boundary, it stops at the edge (this is called clamping)
- When released, the Widget settles into the nearest available grid-aligned position within the page bounds

This automatic alignment helps keep Widgets neatly organised, even near the edges.

Try dragging the widget in the example below to see the grid lines and snapping behaviour in action.

#### Layout Grid

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/layout-grid/angular/)

## Customisations

Page settings also include universal styling options that apply across the page. At page level, the page background can be changed and default Widget styles can be defined. Each widget can override those defaults from the Widget section of its own Format tab.

Click on the page section in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#edit-panel) to access page customisation options and see how styling changes take effect across the page.

#### Page Customisation

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Page Customisation](https://www.ag-grid.com/studio/archive/3.0.0/examples/page-settings/page-customisation/angular/)
